assert( oRA, "oRA not found!")

------------------------------
--      Are you local?      --
------------------------------

local L = AceLibrary("AceLocale-2.0"):new("oRALMainTank")

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	["maintank"] = true,
	["MainTank"] = true,
	["maintankleader"] = true,
	["mt"] = true,
	["Options for the maintanks."] = true,
	["set"] = true,
	["Set Maintank"] = true,
	["Set a maintank."]= true,
	["<nr> <name>"] = true,
	["<nr>"] = true,
	["Remove Maintank"] = true,
	["remove"] = true,
	["Remove a maintank."] = true,
	["Removed maintank: "] = true,
	["Set maintank: "] = true,
	["Leader/MainTank"] = true,
} end )

----------------------------------
--      Module Declaration      --
----------------------------------

oRALMainTank = oRA:NewModule(L["maintankleader"])
oRALMainTank.defaults = {
}
oRALMainTank.leader = true
oRALMainTank.name = L["Leader/MainTank"]
oRALMainTank.consoleCmd = L["mt"]
oRALMainTank.consoleOptions = {
	type = "group",
	desc = L["Options for the maintanks."],
	name = L["MainTank"],
	args = {
		[L["set"]] = {
			name = L["Set Maintank"], type = "text",
			desc = L["Set a maintank."],
			usage = L["<nr> <name>"],
			get = function() return "" end,
			set = function(v)
				oRALMainTank:Set(v)
			end,
			validate = function(v)
				return string.find(v, "^(%d+)")
			end,
			disabled = function() return not oRALMainTank:IsValidRequest() end,
		},
		[L["remove"]] = {
			name = L["Remove Maintank"], type = "text",
			desc = L["Remove a maintank."],
			usage = L"<nr>",
			get = function() return "" end,
			set = function(v)
				oRALMainTank:Remove(v)
			end,
			validate = function(v)
				return string.find(v, "^(%d+)$")
			end,
			disabled = function() return not oRALMainTank:IsValidRequest() end,
		}
	}
}


------------------------------
--      Initialization      --
------------------------------

function oRALMainTank:OnInitialize()
	self.debugFrame = ChatFrame5
end

function oRALMainTank:OnEnable()
	if not self.core.maintanktable then 
		self.core.maintanktable = self.core.db.profile.maintanktable or {}
	end
	self:RegisterEvent("oRA_SendVersion")
end

function oRALMainTank:OnDisable()
	self:UnregisterAllEvents()
end

-------------------------------
--       Event Handlers      --
-------------------------------

function oRALMainTank:oRA_SendVersion()
	if (not IsRaidLeader()) then return end
	for k,v in pairs(self.core.maintanktable) do
		if self:IsValidRequest(v,true) then self:SendMessage("SET "..k.." "..v) end
	end
end

-------------------------------
--      Command Handlers     --
-------------------------------

function oRALMainTank:Set( text )
	if not self:IsPromoted() then return end
	if not text or text == "" then return end
	local _, _, num, name = string.find(text, "(%S+)%s*(.*)")
	if not num then return end

	num = tonumber(num)
	if not name or name == "" then name = UnitName("target") end
	
	-- lower the name and upper the first letter
	name = string.upper(string.sub(name, 1, 1)) .. string.lower(string.sub(name, 2))

	if not self:IsValidRequest(name, true) then return end
	
	self:SendMessage( "SET " .. num .. " " .. name )
	self:Print(L["Set maintank: "] .. num .. " " .. name )
end

function oRALMainTank:Remove( num )
	if not self:IsPromoted() then return end
	if not num then return end
	num = tonumber(num)
	local name = self.core.maintanktable[num]
	if not name then return end
	self:SendMessage( "R "..name )
	self:Print(L["Removed maintank: "] .. num .." "..name )
end
