otravi_CastingBar.Default	= {
	width		= 255,
	height		= 25,
	time		= 12,
	spell		= 10,
	delay		= 14,
	lock		= 1,
	border		= 1,
	cspell		= '1 .7 0',
	csuccess	= '0 1 0',
	cchannel	= '.3 .3 1',
	cfailed		= '1 0 0',
	texture		= 'otravi'
}

otravi_CastingBar.Textures	= {
	otravi		= "Interface\\AddOns\\otravi_CastingBar\\Textures\\otravi",
	perl		= "Interface\\AddOns\\otravi_CastingBar\\Textures\\perl",
	smooth		= "Interface\\AddOns\\otravi_CastingBar\\Textures\\smooth",
	default		= "Interface\\TargetingFrame\\UI-StatusBar",
	striped		= "Interface\\AddOns\\otravi_CastingBar\\Textures\\striped",
}

local const		= otravi_CastingBar.Const
local tex		= otravi_CastingBar.Textures

otravi_CastingBar	= AceAddonClass:new({
	name		= const.Title,
	version       	= "1.2." .. string.sub("$Revision: 9181 $", 12, -3), 
	releaseDate   	= string.sub("$Date: 2006-08-26 04:19:38 -0700 (Sat, 26 Aug 2006) $", 8, 17),
	description	= const.Desc,
	author		= "haste",
	authorEmail	= "haste@haste3k.net",
	aceCompatible	= "103",
	category	= ACE_CATEGORY_INTERFACE,
	db		= AceDbClass:new("otravi_CastingBarDB"),
	defaults	= otravi_CastingBar.Default,
	cmd		= AceChatCmdClass:new(const.ChatCmd,const.ChatOpt),
	
	e		= 0,
	holdTime	= 0,
	maxValue	= 0,

	Initialize = function(self)
		self:CheckVariables()
		self:CreateCB()
	end,
	
	Disable = function(self)
		self:AddBlizzCB()
	end,
	
	Enable = function(self)
		self:SetPosition()
		self:Events()
		self:RemoveBlizzCB()
	end,
	
	Events = function(self)
		self:RegisterEvent("SPELLCAST_START")
		self:RegisterEvent("SPELLCAST_STOP", "SpellStop")
		self:RegisterEvent("SPELLCAST_INTERRUPTED","SpellFailed")
		self:RegisterEvent("SPELLCAST_FAILED", "SpellFailed")
		self:RegisterEvent("SPELLCAST_DELAYED", "SpellDelayed")
		self:RegisterEvent("SPELLCAST_CHANNEL_START", "SpellChannelStart")
		self:RegisterEvent("SPELLCAST_CHANNEL_STOP", "SpellChannelStop")
		self:RegisterEvent("SPELLCAST_CHANNEL_UPDATE", "SpellChannelUpdate")
	end,
	
	AddBlizzCB = function(self)
		CastingBarFrame:RegisterEvent("SPELLCAST_START")
		CastingBarFrame:RegisterEvent("SPELLCAST_STOP")
		CastingBarFrame:RegisterEvent("SPELLCAST_INTERRUPTED")
		CastingBarFrame:RegisterEvent("SPELLCAST_FAILED")
		CastingBarFrame:RegisterEvent("SPELLCAST_DELAYED")
		CastingBarFrame:RegisterEvent("SPELLCAST_CHANNEL_START")
		CastingBarFrame:RegisterEvent("SPELLCAST_CHANNEL_STOP")
	end,
	
	RemoveBlizzCB = function(self)
		CastingBarFrame:UnregisterEvent("SPELLCAST_START")
		CastingBarFrame:UnregisterEvent("SPELLCAST_STOP")
		CastingBarFrame:UnregisterEvent("SPELLCAST_INTERRUPTED")
		CastingBarFrame:UnregisterEvent("SPELLCAST_FAILED")
		CastingBarFrame:UnregisterEvent("SPELLCAST_DELAYED")
		CastingBarFrame:UnregisterEvent("SPELLCAST_CHANNEL_START")
		CastingBarFrame:UnregisterEvent("SPELLCAST_CHANNEL_STOP")
	end,
	
	CheckVariables = function(self)
		if not self:G("cspell") then self:S("cspell", '1 .7 0') end
		if not self:G("csuccess") then self:S("csuccess", '0 1 0') end
		if not self:G("cchannel") then self:S("cchannel", '.3 .3 1') end
		if not self:G("cfailed") then self:S("cfailed", '1 0 0') end
		if not self:G("texture") then self:S("texture", "otravi") end
	end,
	
	SetPosition = function(self)
		if not self:G("PosX") then
			self.master:ClearAllPoints()
			self.master:SetPoint("CENTER", UIParent, "CENTER", 0, 0)			
		else
			self:RestorePosition()
		end
	end,
	
	CreateCB = function(self)
		local w,h,t,s,d,b,bt,ef,es = self:G("width"), self:G("height"), self:G("time"), self:G("spell"), self:G("delay"), self:G("border"), self:G("texture")
		self.master = CreateFrame("Frame", "otravi_CastingBarFrame", UIParent)
		self.master:Hide()
		self.master:SetScript("OnUpdate", self.OnUpdate)
		self.master:SetMovable(true)
		self.master:EnableMouse(true)
		self.master:SetWidth(w+9)
		self.master:SetHeight(h+10)

		if b then ef,es = "Interface\\Tooltips\\UI-Tooltip-Border", 16 end
		self.master:SetBackdrop({
			bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
			edgeFile = ef or "", edgeSize = es or "",
			insets = {left = 5, right = 5, top = 5, bottom = 5},
			})
		self.master:RegisterForDrag("LeftButton")
		self.master:SetScript("OnDragStart", function() if not self:G("lock") then self["master"]:StartMoving() end end)
		self.master:SetScript("OnDragStop", function() self["master"]:StopMovingOrSizing() self:SavePosition() end)
		self.master:SetBackdropBorderColor(TOOLTIP_DEFAULT_COLOR.r, TOOLTIP_DEFAULT_COLOR.g, TOOLTIP_DEFAULT_COLOR.b)
		self.master:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
		
		local f, _, _ = GameFontHighlightSmall:GetFont()
		local bar = CreateFrame("StatusBar", nil, self.master)
		bar:ClearAllPoints()
		bar:SetPoint("CENTER", self.master, "CENTER", 0, 0)
		bar:SetWidth(w)
		bar:SetHeight(h)
		bar:SetStatusBarTexture(tex[bt] or tex.otravi)
		self.master.Bar = bar
		
		local spark = bar:CreateTexture(nil, "OVERLAY")
		spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
		spark:SetWidth(16)
		spark:SetHeight(h+25)
		spark:SetBlendMode("ADD")
		self.master.Spark = spark
		
		local font = bar:CreateFontString(nil, "OVERLAY")
		font:SetJustifyH("RIGHT")
		font:SetFont(f,t)
		font:SetText("X.Y")
		font:ClearAllPoints()
		font:SetPoint("RIGHT", self.master.Bar, "RIGHT",-10,0)
		self.master.Time = font
		
		local spell = bar:CreateFontString(nil, "OVERLAY")
		spell:SetJustifyH("CENTER")
		spell:SetWidth(w-self.master.Time:GetWidth())
		spell:SetFont(f,s)
		spell:ClearAllPoints()
		spell:SetPoint("LEFT", self.master, "LEFT",10,0)
		self.master.Spell = spell
		
		local delay = bar:CreateFontString(nil, "OVERLAY")
		delay:SetTextColor(1,0,0,1)
		delay:SetJustifyH("RIGHT")
		delay:SetFont(f,d)
		delay:SetText("X.Y")
		delay:ClearAllPoints()
		delay:SetPoint("TOPRIGHT", self.master.Bar, "TOPRIGHT",-10,20)
		self.master.Delay = delay
	end,
	
	SPELLCAST_START = function(self)
		self:SpellStart(arg1, arg2)
	end,
	
	SpellStart = function(self, s, d)
		if not self:G("lock") then
			self:Msg("Please lock your casting bar before casting a spell")
			return
		end
		
		local _,_,r,g,b = string.find(self:G("cspell"), "(%d*%.?%d*)%s*(%d*%.?%d*)%s*(%d*%.?%d*)")
		
		self.startTime = GetTime()
		self.maxValue = self.startTime + (d / 1000)
		
		self.master.Bar:SetStatusBarColor(r or 0, g or 0, b or 0)
		self.master.Bar:SetMinMaxValues(self.startTime, self.maxValue )
		self.master.Bar:SetValue(0)
		self.master.Spell:SetText(s)
		self.master:SetAlpha(1)
		self.master.Time:SetText("")
		self.master.Delay:SetText("")
			
		self.holdTime 	= 0
		self.delay 	= 0
		self.casting 	= 1
		self.fadeOut 	= nil
		
		self.master:Show()
		self.master.Spark:Show()
	end,
	
	SpellStop = function(self)
		if not self:G("lock") then return end
		
		local _,_,r,g,b = string.find(self:G("csuccess"), "(%d*%.?%d*)%s*(%d*%.?%d*)%s*(%d*%.?%d*)")
		
		self.master.Bar:SetValue(self.maxValue)
		
		if not self.channeling then
			self.master.Bar:SetStatusBarColor(r or 0,g or 0, b or 0)
			self.master.Spark:Hide()
		end
		
		self.delay 	= 0
		self.casting 	= nil
		self.fadeOut 	= 1
	end,
	
	SpellFailed = function(self)
		if not self:G("lock") then return end
		
		local _,_,r,g,b = string.find(self:G("cfailed"), "(%d*%.?%d*)%s*(%d*%.?%d*)%s*(%d*%.?%d*)")

		self.master.Bar:SetValue(self.maxValue)
		self.master.Bar:SetStatusBarColor(r or 0, g or 0, b or 0)
		self.master.Spark:Hide()
		
		if (event == "SPELLCAST_FAILED") then
			self.master.Spell:SetText(FAILED)
		else
			self.master.Spell:SetText(INTERRUPTED)
		end
		
		self.casting = nil
		self.channeling = nil
		self.fadeOut = 1
		self.holdTime = GetTime() + 1
	end,
	
	SpellDelayed = function(self)
		if not self:G("lock") then return end
		
		local d = arg1 / 1000
		
		if(self.master:IsShown()) then
			if self.delay == nil then self.delay = 0 end
			
			self.startTime = self.startTime + d
			self.maxValue = self.maxValue + d
			self.delay = self.delay + d
			
			self.master.Bar:SetMinMaxValues(self.startTime, self.maxValue)
		end
	end,
	
	SpellChannelStart = function(self)
		if not self:G("lock") then
			self:Msg("Please lock your casting bar before casting a spell")
			return
		end
		
		local d = arg1 / 1000
		local _,_,r,g,b = string.find(self:G("cchannel"), "(%d*%.?%d*)%s*(%d*%.?%d*)%s*(%d*%.?%d*)")
		
		self.startTime = GetTime()
		self.endTime = self.startTime + d
		self.maxValue = self.endTime
		
		self.master.Bar:SetStatusBarColor(r or 0, g or 0, b or 0)
		self.master.Bar:SetMinMaxValues(self.startTime, self.endTime)
		self.master.Bar:SetValue(self.endTime)
		self.master.Spell:SetText(arg2)
		self.master.Time:SetText("")
		self.master.Delay:SetText("")
		self.master:SetAlpha(1)
		
		self.holdTime = 0
		self.casting = nil
		self.channeling = 1
		self.fadeOut = nil
		
		self.master:Show()
		self.master.Spark:Show()
	end,
	
	SpellChannelStop = function(self)
		if not self:G("lock") then return end
		if not self.channeling then return end
		
		local _,_,r,g,b = string.find(self:G("csuccess"), "(%d*%.?%d*)%s*(%d*%.?%d*)%s*(%d*%.?%d*)")
		
		self.master.Bar:SetValue(self.endTime)
		self.master.Bar:SetStatusBarColor(r or 0, g or 0, b or 0)
		self.master.Spark:Hide()
		
		self.delay = 0
		self.casting = nil
		self.channeling = nil
		self.fadeOut = 1
	end,
	
	SpellChannelUpdate = function(self)
		if not self:G("lock") then return end
		
		local d = arg1 / 1000
		
		if(self.master:IsShown()) then
			local origDuration = self.endTime - self.startTime
			
			if self.delay == nil then self.delay = 0 end
			
			self.delay = self.delay + d
			self.endTime = GetTime() + d
			self.maxValue = self.endTime
			self.startTime = self.endTime - origDuration
			
			self.master.Bar:SetMinMaxValues(self.startTime, self.endTime)
		end
	end,
	
	OnUpdate = function()
		local self = otravi_CastingBar
		self.e = self.e + arg1
		if(self.e > .1 and self.casting) then
			local delay, n, sp = false, GetTime(), 0
			
			if ( n > self.maxValue ) then n = self.maxValue end
			
			self.master.Time:SetText(string.format( "%.1f", math.max(self.maxValue - n, 0.0)))
			
			if (self.delay ~= 0) then delay = 1 end
			if (delay) then
				self.master.Delay:SetText("+"..string.format("%.1f", self.delay or "" ))
			else 
				self.master.Delay:SetText("")
			end
			
			self.master.Bar:SetValue(n)
			
			local w = self.master.Bar:GetWidth()
			sp = ((n - self.startTime) / (self.maxValue - self.startTime)) * w
			if( sp < 0 ) then sp = 0 end
			
			self.master.Spark:SetPoint("CENTER", self["master"]["Bar"], "LEFT", sp, 0)
		elseif (self.e > .05 and self.channeling) then
			local delay, n, sp = false, GetTime(), 0
			
			if (n > self.endTime) then n = self.endTime end
			if (n == self.endTime) then
				self.channeling = nil
				self.fadeOut = 1
				return
			end
	
			local b = self.startTime + (self.endTime - n)
			
			self.master.Time:SetText(string.format( "%.1f", math.max(self.maxValue - n, 0.0)))
			
			if (self.delay ~= 0) then delay = 1 end
			if (delay) then
				self.master.Delay:SetText("-"..string.format("%.1f", self.delay ))
			else 
				self.master.Delay:SetText("")
			end
			
			self.master.Bar:SetValue(b)
			
			local w = self.master.Bar:GetWidth()
			sp = ((b - self.startTime) / (self.endTime - self.startTime)) * w
			
			self.master.Spark:SetPoint("CENTER", self["master"]["Bar"], "LEFT", sp, 0)
		elseif(GetTime() < self.holdTime) then
			return
		elseif(self.fadeOut and self:G("lock")) then
			local a = this:GetAlpha() - .05
			
			if (a > 0) then
				self.master:SetAlpha(a)
			else
				self.fadeOut = nil
				self.master:Hide()
				self.master.Time:SetText("")
				self.master.Delay:SetText("")
				self.master:SetAlpha(1)
			end
		end
	end,
	
	SavePosition = function(self)	
		local f = otravi_CastingBarFrame
		local x,y = f:GetLeft(), f:GetTop()
		local s = f:GetEffectiveScale()
		
		x,y = x*s,y*s
		
		self:S("PosX", x)
		self:S("PosY", y)
	end,
	
	RestorePosition = function(self)
		local x = self:G("PosX")
		local y = self:G("PosY")
		
		if not x or not y then return end
				
		local f = otravi_CastingBarFrame
		local s = f:GetEffectiveScale()
	
		x,y = x/s,y/s
	
		f:ClearAllPoints()
		f:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", x, y)
	end,
	
	chatLock = function(self)
		self:S("lock",1)
		
		self.master:Hide()
		
		self:Msg("The casting bar is now locked into it's current position.")
	end,
	
	chatUnlock = function(self)
		self:S("lock",nil)
		
		self.master:Show()
		self.master.Bar:SetStatusBarColor(.3, .3, .3)
		self.master.Time:SetText("1.3")
		self.master.Delay:SetText("+0.8")
		self.master.Spell:SetText("Call Of The Blameworthy Vanity")
		
		self:Msg("The casting bar is now unlocked and movable.")
	end,
	
	chatSetWidth = function(self, w)
		local w = tonumber(w)
				
		if(not w) then
			self:Msg("The current [width] value is: "..self:G("width"))
			self:Msg("The default [width] value is: 255")
			return
		end
		
		if(w < 100 or w > 1200) then
			self:Msg("Please select a width between 100 to 1200")
			return
		end
		
		self.master:SetWidth(w+9)
		self.master.Bar:SetWidth(w)
		self.master.Time:SetText("X.Y")
		self.master.Spell:SetWidth(w-self.master.Time:GetWidth())
		
		self:S("width",w)
		self:Msg("Width set to: "..w)
	end,
	
	chatSetHeight = function(self, h)
		local h = tonumber(h)
		
		if not h then
			self:Msg("The current [height] value is: "..self:G("height"))
			self:Msg("The default [height] value is: 25")
			return
		end
		
		if(h < 10 or h > 60) then
			self:Msg("Please select a height between 10 to 60")
			return
		end
		
		self.master:SetHeight(h+10)
		self.master.Spark:SetHeight(h+25)
		self.master.Bar:SetHeight(h)
		
		self:S("height",h)
		self:Msg("Height set to: "..h)
	end,
	
	chatSetBorder = function(self)
		self:TogLoc("border")
		
		local b,ef,es = self:G("border")
		
		if(b) then ef,es = "Interface\\Tooltips\\UI-Tooltip-Border", 16 end

		self.master:SetBackdrop({
			bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
			edgeFile = ef or "", edgeSize = es or "",
			insets = {left = 5, right = 5, top = 5, bottom = 5},
		})
		self.master:SetBackdropBorderColor(TOOLTIP_DEFAULT_COLOR.r, TOOLTIP_DEFAULT_COLOR.g, TOOLTIP_DEFAULT_COLOR.b)
		self.master:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
		
		self:Msg(ACE_CMD_REPORT_LINE, "Border is now: ", ACEG_MAP_ONOFF[b or 0])
	end,
	
	chatFontSpell = function(self, s)
		local s = tonumber(s)
		
		if not s then
			self:Msg("The current [spell] font size is: "..self:G("spell"))
			self:Msg("The default [spell] font size is: 10")
			return
		end
		
		local f, _, _ = GameFontHighlightSmall:GetFont()
		
		self.master.Spell:SetFont(f,s)
		
		self:S("spell",s)
		self:Msg("Font size on the spell names are set to: "..s)
	end,
	
	chatFontTime = function(self, t)
		local t = tonumber(t)
		
		if not t then
			self:Msg("The current [cast time] font size is: "..self:G("time"))
			self:Msg("The default [cast time] font size is: 12")
			return
		end
		
		local f, _, _ = GameFontHighlightSmall:GetFont()
		
		self.master.Time:SetFont(f,t)
		
		self:S("time",t)
		self:Msg("Font size on the cast time are set to: "..t)
	end,
	
	chatFontDelay = function(self, d)
		local d = tonumber(d)
		
		if not d then
			self:Msg("The current [delay time] font size is: "..self:G("delay"))
			self:Msg("The default [delay time] font size is: 14")
			return
		end
		
		local f, _, _ = GameFontHighlightSmall:GetFont()
		
		self.master.Delay:SetFont(f,d)
		
		self:S("delay",d)
		self:Msg("Font size on the delayed cast time are set to: "..d)
	end,
	
	chatSetColors = function(self, m)
		local m = string.lower(m)
		local _,_,type,r,g,b = string.find(m, "(%a+)%s*(%d*%.?%d*)%s*(%d*%.?%d*)%s*(%d*%.?%d*)")
		r,g,b = r or 0, g or 0, b or 0
		
		if type == "spell" then
			self:S("cspell", r.." "..g.." "..b)
		elseif type == "success" then
			self:S("csuccess", r.." "..g.." "..b)
		elseif type == "channel" then
			self:S("cchannel", r.." "..g.." "..b)
		elseif type == "failed" then
			self:S("cfailed", r.." "..g.." "..b)
		else
			self:Msg("Usage is /ocb colors [spell|success|channel|failed] r g b.")
			return
		end
	
		self:Msg("Setting colors for %s to %s, %s, %s.", type, r, g, b)
	end,
	
	chatChangeTexture = function(self, m)
		local m = string.lower(m)
		
		if not m then
			self:Msg("Valid texures are: otravi, smooth, perl and default.")
		elseif tex[m] then
			self.master.Bar:SetStatusBarTexture(tex[m])
			self:S("texture", m)
		else
			self:Msg("Invalid texture, valid textures are: otravi, smooth, perl, striped, and default.")
		end
	end,
   
})

otravi_CastingBar:RegisterForLoad()

ace:RegisterFunctions(otravi_CastingBar, {
   version = 1.0,

	G = function(self, var)
		return self.db:get(self.profilePath, var)
	end,
	S = function(self, var, val)
	self.db:set(self.profilePath, var, val)
	end,
	Msg = function(self, ...)
		self.cmd:msg(unpack(arg))
	end,
	TogLoc	= function(self, v)
		return self.db:toggle(self.profilePath,v)
	end,
})

-->> ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ <<--
-- Fin.                                                  --
-->> ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ <<--